// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id: game_command.h 2025 2010-12-10 03:45:39Z mike $
//
// Copyright (C) 2006-2010 by The Odamex Team.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// DESCRIPTION:
//	Launch a Game Instance
//
// AUTHORS:
//	 Michael Wood (mwoodj at huntsvegas dot org)
//
//-----------------------------------------------------------------------------

#ifndef _GAME_COMMAND_H
#define _GAME_COMMAND_H

#include <list>

class GameCommand
{
public:
	void AddParameter(std::string parameter);
	void AddParameter(std::string parameter, std::string value);

	int Launch();

private:
	static void *Cleanup(void *vpPID);
	void         Cleanup(AG_ProcessID pid);

	std::list<std::string> Parameters;
};

#endif
